;
; FREZZE HER
;
.CONST
Number_Of_Flakes				EQU 1024					;; ) any combination until =< 64 Kb
Size_Of_Flakes_Structure			EQU 16					;; )

; this structure is only here for info (coz i use reg+displacement)
Flake_Structure	STRUCT
	X_Position		DWORD ?
	Y_Position		DWORD ?
	Movment_Position	DWORD ?
	unused			DWORD ?
Flake_Structure	ENDS


.DATA
Snow_Table_Width_Movments	DWORD 0,1,2,3,3,4,4,5,5,5,4,4,3,3,2,1
						DWORD -0,-1,-2,-3,-3,-4,-4,-5,-5,-5,-4,-4,-3,-3,-2,-1

; sprite 1
ALIGN 16
Snow_Sprite_01		DWORD 5								;; width of the sprite, in pixels
				DWORD 5								;; height of the sprite, in pixels
				DWORD OFFSET Snow_Sprite_01_Data			;; address of the pixels
				DWORD 000000000h						;; color used for transparence

ALIGN 16																	;; ) do not separate them (here it simulate my sprite file format
Snow_Sprite_01_Infos	Sprite_Info <?>										;; ) and i don't want to rewritte my algos just for few sprites...)
Snow_Sprite_01_Data		DWORD 000000000h,01F1F1FFFh,07F7F7FFFh,01F1F1FFFh,000000000h	;; )
					DWORD 01F1F1FFFh,0AFAFAFFFh,0DFDFDFFFh,0AFAFAFFFh,01F1F1FFFh	;; )
					DWORD 07F7F7FFFh,0DFDFDFFFh,0FFFFFFFFh,0DFDFDFFFh,07F7F7FFFh	;; )
					DWORD 01F1F1FFFh,0AFAFAFFFh,0DFDFDFFFh,0AFAFAFFFh,01F1F1FFFh	;; )
					DWORD 000000000h,01F1F1FFFh,07F7F7FFFh,01F1F1FFFh,000000000h	;; )


; sprite 2
ALIGN 16
Snow_Sprite_02		DWORD 3								;; width of the sprite, in pixels
				DWORD 3								;; height of the sprite, in pixels
				DWORD OFFSET Snow_Sprite_02_Data			;; address of the pixels
				DWORD 000000000h						;; color used for transparence

ALIGN 16												;; ) do not separate them (here it simulate my sprite file format
Snow_Sprite_02_Infos	Sprite_Info <?>					;; ) and i don't want to rewritte my algos just for few sprites...)
Snow_Sprite_02_Data		DWORD 000000000h,07F7F7FFFh,000000000h	;; )
					DWORD 07F7F7FFFh,0FFDFDFFFh,07F7F7FFFh	;; )
					DWORD 000000000h,07F7F7FFFh,000000000h	;; )


.CODE
cmp MP_Init_Effect_02,1
jne MP_Apply_Effect_02
;
; init here
;
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


;
; init the sprites (in fact we collect some infos, and fill a structure that group all infos needed)
;

; for the first sprite
		mov edx,OFFSET Snow_Sprite_01
		mov esi,OFFSET Snow_Sprite_01_Infos
		mov edi,OFFSET Work_Screen
		call InitSprite
; for the second sprite
		mov edx,OFFSET Snow_Sprite_02
		mov esi,OFFSET Snow_Sprite_02_Infos
		mov edi,OFFSET Work_Screen
		call InitSprite


;
; generate the start position of the flakes :
;
		mov edx,Structures_Area.Pointer					;; put the start address of the structures area in edx
		mov ecx,Number_Of_Flakes*Size_Of_Flakes_Structure		;; put the used area of structures in ecx
		add edx,ecx									;; add this size to the start address
		neg ecx										;; invert ecx (it become our loop counter)
Snow_CreateNewFlake:
		mov ebx,Work_Screen.Screen_Width					;; ) generate a rnd number for the screen position x
		dec ebx										;; )
		call GenerateRandomNumber						;; )
		mov DWORD PTR [edx+ecx],eax						;; )
		mov ebx,Work_Screen.Screen_Height					;;	) generate a rnd number for the screen position y
		dec ebx										;;	)
		call GenerateRandomNumber						;;	)
		mov DWORD PTR [edx+ecx+4],eax						;;	)
		mov ebx,31									;; ) generate a rnd number for the position in the table of width movments
		call GenerateRandomNumber						;; )
		mov DWORD PTR [edx+ecx+8],eax						;; )
		mov ebx,3										;;	) generate a rnd number for the speed
		call GenerateRandomNumber						;;	)
		inc eax										;; incrmenter le rsultat (pour ne pas avoir de 0)
		mov DWORD PTR [edx+ecx+12],eax					;; inc the result (to not have 0)
; end of the loop
		add ecx,Size_Of_Flakes_Structure					;; inc the counter to pass to the next structure
		jnz Snow_CreateNewFlake							;; while it's not zero, go to Snow_CreateNewFlake


;
; simply copy the backup of the screen (it serve as transission image)
;
		mov eax,Work_Screen.Screen_Size
		mov esi,Backup_Screen.Pointer
		mov edi,Work_Screen.Pointer
		call CopyMemArea_Mmx


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
mov MP_Init_Effect_02,0
jmp MP_End_Effect_02
MP_Apply_Effect_02:
;
; effect here
;
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


;
; copy the backup of the srceen, and we will work on the copy
;
		mov eax,Work_Screen.Screen_Size
		mov esi,Backup_Screen.Pointer
		mov edi,Work_Screen.Pointer
		call CopyMemArea_Mmx


;
; apply the filter
;
		mov edi,OFFSET Work_Screen
		call ScreenFilter_SwapRedsBlues_Mmx


;
; draw the flakes
;
		mov edx,Structures_Area.Pointer					;; put the start address of the structures area in edx
		mov ecx,Number_Of_Flakes*Size_Of_Flakes_Structure		;; put the used area of structures in ecx
		add edx,ecx									;; add this size to the start address
		neg ecx										;; invert ecx (it become our loop counter)
Snow_DrawFlake:
		mov ebx,OFFSET Snow_Table_Width_Movments			;; put the offset of the table in ebx
		mov eax,DWORD PTR [edx+ecx+8]						;; read the movment in the table
		inc eax										;; inc the position in the table of movments
		and eax,00000001Fh								;; keep the value from 0 to 31
		mov DWORD PTR [edx+ecx+8],eax						;; save the width movment of the flake
		mov eax,DWORD PTR [eax*4+ebx]						;; put the width movment position in eax
		mov ebx,DWORD PTR [edx+ecx+4]						;; ) read the y position
		add eax,DWORD PTR [edx+ecx]						;; ) add the x position
		cmp DWORD PTR [edx+ecx+12],2						;; compare speed with 2
		jle Snow_Background								;; lower or equal ? then go to Snow_Background
		mov esi,OFFSET Snow_Sprite_01_Infos				;; ) otherwise we use the first sprite
		jmp Snow_Foreground
Snow_Background:
		mov esi,OFFSET Snow_Sprite_02_Infos				;; ) use of the second sprite
Snow_Foreground:
		mov edi,OFFSET Work_Screen						;; )
		call DisplayCenteredSprite_Mmx					;; ) drawn sprite

		add ebx,DWORD PTR [edx+ecx+12]					;; add the next Y movmemt
		cmp ebx,Work_Screen.Screen_Height					;;	) is it lower than Hauteur_Ecran_Travail, then go to Snow_AvoidNewFlake
		jl Snow_AvoidNewFlake							;;	)
; new flake
		mov ebx,Work_Screen.Screen_Width					;; ) generate a rnd number for the screen position x
		dec ebx										;; )
		call GenerateRandomNumber						;; )
		mov DWORD PTR [edx+ecx],eax						;; )
		mov ebx,31									;;	) generate a rnd number for the position in the table of width movments
		call GenerateRandomNumber						;;	)
		mov DWORD PTR [edx+ecx+8],eax						;;	)
		mov ebx,3										;; ) generate a rnd number for the speed
		call GenerateRandomNumber						;; )
		inc eax										;; inc the result (to not have 0)
		mov DWORD PTR [edx+ecx+12],eax					;; save the speed (1 to 4)
		xor ebx,ebx									;; clean ebx
Snow_AvoidNewFlake:
		mov DWORD PTR [edx+ecx+4],ebx						;; put the new Y position in the structure
; end of the loop
		add ecx,Size_Of_Flakes_Structure					;; inc the counter to pass to the next structure
		jnz Snow_DrawFlake								;; while it's not zero, go to Snow_DrawFlake


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; end of the effect here
;
MP_End_Effect_02:

